#include "publicacoes.h"

void Artigo::print () const {
    cout << "\t\tArtigo: " << titulo << ", "; 
    autor->print();
    cout << ", Pginas: de " << pg_ini << "  " << pg_fim << endl; 
}

Edicao & Edicao::operator<<(const Artigo & a)
{
    artigos.push_back(a);

    return *this;
}

void Edicao::print()
{
    cout << "\tEdio: " << titulo << ", "; 
    if(editor)
	editor->print();
    cout << ", Volume: " << volume << ", Nmero: " << numero; 
    cout << ", Pginas: " << paginas;
    cout << ", Ms: " << mes << ", Ano: " << ano << endl; 
    if(!artigos.empty())
	for(list<Artigo>::iterator artigo = artigos.begin(); 
	    artigo != artigos.end(); 
	    ++artigo)
	    artigo->print();
}

void Livro::print()
{
    cout << "Livro: " << titulo << endl; 
    if(autor) {
	cout << "\t"; 
	autor->print();
	cout << endl; 
    }
    if(tradutor) {
	cout << "\t"; 
	tradutor->print();
	cout << endl; 
    }
    if(editora) {
	cout << "\t"; 
	editora->print();
	cout << endl; 
    }
    cout << "\tEdiao: " << edicao << ", Pginas: " << paginas << endl;
    cout << "\tAno: " << ano << ", ISBN: " << isbn << endl;
}

Periodico & Periodico::operator<<(const Edicao & e)
{
    edicoes.push_back(e);
    return *this;
}

void Periodico::print () 
{
    cout << "Peridico: " << titulo << endl; 
    if(editora) {
	cout << "\t";
	editora->print();
	cout << endl;
    }
    if(!edicoes.empty())
	for(list<Edicao>::iterator edicao = edicoes.begin(); 
	    edicao != edicoes.end(); 
	    ++edicao)
	    edicao->print();
    cout << "\tISSN: " << issn << endl;
}
